/* -*- Mode: JavaScript; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (c) 2006, 2007 ActiveState Software Inc.
 * Refer to the license in the Komodo IDE installation
 * for the licensing information of this source code.
 *
 * Contributor(s):
 *   Eric Promislow, <ericp@activestate.com>, original author
 * With hints from the mozilla venkman debugger by
 *   Robert Ginda, <rginda@netscape.com>
 */

if (typeof(JSDBGP) == 'undefined') {
    var JSDBGP = {};
}


JSDBGP.Constants = {
    JSD_CTRID           : "@mozilla.org/js/jsd/debugger-service;1",

    TYPE_VOID     : Components.interfaces.jsdIValue.TYPE_VOID,
    TYPE_NULL     : Components.interfaces.jsdIValue.TYPE_NULL,
    TYPE_BOOLEAN  : Components.interfaces.jsdIValue.TYPE_BOOLEAN,
    TYPE_INT      : Components.interfaces.jsdIValue.TYPE_INT,
    TYPE_DOUBLE   : Components.interfaces.jsdIValue.TYPE_DOUBLE,
    TYPE_STRING   : Components.interfaces.jsdIValue.TYPE_STRING,
    TYPE_FUNCTION : Components.interfaces.jsdIValue.TYPE_FUNCTION,
    TYPE_OBJECT   : Components.interfaces.jsdIValue.TYPE_OBJECT,

    PROP_ENUMERATE : Components.interfaces.jsdIProperty.FLAG_ENUMERATE,
    PROP_READONLY  : Components.interfaces.jsdIProperty.FLAG_READONLY,
    PROP_PERMANENT : Components.interfaces.jsdIProperty.FLAG_PERMANENT,
    PROP_ALIAS     : Components.interfaces.jsdIProperty.FLAG_ALIAS,
    PROP_ARGUMENT  : Components.interfaces.jsdIProperty.FLAG_ARGUMENT,
    PROP_VARIABLE  : Components.interfaces.jsdIProperty.FLAG_VARIABLE,
    PROP_EXCEPTION : Components.interfaces.jsdIProperty.FLAG_EXCEPTION,
    PROP_ERROR     : Components.interfaces.jsdIProperty.FLAG_ERROR,
    PROP_HINTED    : Components.interfaces.jsdIProperty.FLAG_HINTED,

    SCRIPT_NODEBUG   : Components.interfaces.jsdIScript.FLAG_DEBUG,
    SCRIPT_NOPROFILE : Components.interfaces.jsdIScript.FLAG_PROFILE,

    COLLECT_PROFILE_DATA  : Components.interfaces.jsdIDebuggerService.COLLECT_PROFILE_DATA,

    PCMAP_SOURCETEXT    : Components.interfaces.jsdIScript.PCMAP_SOURCETEXT,
    PCMAP_PRETTYPRINT   : Components.interfaces.jsdIScript.PCMAP_PRETTYPRINT,

    RETURN_CONTINUE   : Components.interfaces.jsdIExecutionHook.RETURN_CONTINUE,
    RETURN_CONT_THROW : Components.interfaces.jsdIExecutionHook.RETURN_CONTINUE_THROW,
    RETURN_VALUE      : Components.interfaces.jsdIExecutionHook.RETURN_RET_WITH_VAL,
    RETURN_THROW      : Components.interfaces.jsdIExecutionHook.RETURN_THROW_WITH_VAL,

    FTYPE_STD     : 0,
    FTYPE_SUMMARY : 1,
    FTYPE_ARRAY   : 2,

    BREAKPOINT_STOPNEVER   : 0,
    BREAKPOINT_STOPALWAYS  : 1,
    BREAKPOINT_STOPTRUE    : 2,
    BREAKPOINT_EARLYRETURN : 3,

    STOP_REASON_STARTING : 0,
    STOP_REASON_STOPPING : 1,
    STOP_REASON_STOPPED : 2,
    STOP_REASON_RUNNING : 3,
    STOP_REASON_BREAK : 4,
    STOP_REASON_INTERACT : 5,
    
    // winger-breakpoints constants
    BKPT_DISABLE : 1,
    BKPT_ENABLE : 2,
    BKPT_TEMPORARY : 3,

    E_MSG_HEADER : "JavaScript Debugger: ",
    E_NONE : [0],
    E_PARSE_ERROR : [1, "Parse error in command"],
    E_DUPLICATE_ARGS : [2, "Duplicate arguments in command"],
    E_INVALID_OPTIONS : [3, "Invalid options"],
    E_UNIMPLEMENTED_CMD : [4, "Unimplemented command"],
    E_CMD_NOT_AVAILABLE : [5, "Command not available"],
    
    E_FILE_OPEN_FAILED : [100, "Can not open file"],
    E_REDIRECT_FAILED : [101, "Stream redirect failed"],
    
    E_BREAKPOINT_NOT_SETTABLE : [200, "Breakpoint could not be set"],
    E_BREAKPOINT_TYPE_NOT_SUPPORTED : [201, "Breakpoint type not supported"],
    E_BREAKPOINT_INVALID : [202, "Invalid breakpoint request"],
    E_BREAKPOINT_NO_CODE : [203, "No code on breakpoint line"],
    E_BREAKPOINT_INVALID_STATE : [204, "Invalid Breakpoint state"],
    E_BREAKPOINT_NO_ID : [205, "No such breakpoint"],
    E_BREAKPOINT_EVAL_ERROR : [206, "Error evaluating code"],
    E_BREAKPOINT_PARSE_ERROR : [207, "Invalid expression"],

    E_PROPERTY_NON_EXISTENT : [300, "Can not get property"],
    E_STACK_DEPTH_INVALID : [301, "Stack depth invalid"],
    E_CONTEXT_INVALID : [302, "Context invalid"],

    E_ENCODING_NOT_SUPPORTED : [900, "Encoding not supported"],
    E_INTERNAL_ERROR : [998, "Internal error"],
    E_UNKNOWN : [999, "Unknown error"],

    StandardURL : 1,
    JavaScriptURL : 2,
    JavaScriptWithBase : 3,
    JavaScriptIndex : 4,
    DBGP_HTTP_URL : 5,
    
    IB_STATE_NONE : 0,
    IB_STATE_START : 1,
    IB_STATE_PENDING : 2,

    DBGP_STATE_DORMANT : 1, 
    DBGP_STATE_CONNECTING : 2,
    DBGP_STATE_CONNECTED : 3,
    DBGP_STATE_RUN : 4,
    DBGP_STATE_BREAK : 5,
    DBGP_STATE_DISCONNECTED : 6,

    DBGB_STATE_STRINGS : ['',
                          "Unused",
                          "Connecting",
                          "Connected",
                          "Running",
                          "Stopped",
                          "Disconnected",
                          ""],
    DBGB_STATE_ICONS : ['',
                        'status_pre_connect.png',
                        'status_connected.png',
                        'status_connected.png',
                        'status_connected.png',
                        'status_connected_break.png',
                        'status_post_connect.png',
                        ''],
                        
    DBGB_STATE_PREFIX : "Komodo JS Debugger: ",
    
    __end__:0
};

JSDBGP.Constants.debugTrap_reasons = [];
JSDBGP.Constants.debugTrap_reasons[Components.interfaces.jsdIExecutionHook.TYPE_BREAKPOINT] = "BREAKPOINT";
JSDBGP.Constants.debugTrap_reasons[Components.interfaces.jsdIExecutionHook.TYPE_DEBUG_REQUESTED] = "DEBUG_REQUESTED";
JSDBGP.Constants.debugTrap_reasons[Components.interfaces.jsdIExecutionHook.TYPE_DEBUGGER_KEYWORD] = "DEBUGGER_KEYWORD";
JSDBGP.Constants.debugTrap_reasons[Components.interfaces.jsdIExecutionHook.TYPE_THROW] = "THROW";
JSDBGP.Constants.debugTrap_reasons[Components.interfaces.jsdIExecutionHook.TYPE_INTERRUPTED] = "INTERRUPTED";

JSDBGP.Constants.NS_OK = 0;
JSDBGP.Constants.NS_ERROR_FAILURE = -2147467259;
JSDBGP.Constants.NS_ERROR_MODULE_NETWORK = 2152398848;
JSDBGP.Constants.NS_NET_STATUS_READ_FROM = JSDBGP.Constants.NS_ERROR_MODULE_NETWORK + 8;
JSDBGP.Constants.NS_NET_STATUS_WROTE_TO  = JSDBGP.Constants.NS_ERROR_MODULE_NETWORK + 9;
JSDBGP.Constants.NS_NET_STATUS_WROTE_TO  = JSDBGP.Constants.NS_ERROR_MODULE_NETWORK + 9;
JSDBGP.Constants.NS_ERROR_NOT_CONNECTED = JSDBGP.Constants.NS_ERROR_MODULE_NETWORK + 12;
